/*
   Copyright Universite de Versailles Saint-Quentin en Yvelines 2009
   AUTHORS: Sebastien Briais, Sid-Ahmed-Ali Touati

   This file is part of GDD.
   
   GDD is free software: you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.
   
   GDD is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with GDD.  If not, see
   <http://www.gnu.org/licenses/>.
*/
#ifndef __GDD_ARCH_XML_H
#define __GDD_ARCH_XML_H
/** \file arch_xml.h
    \brief Architecture parser */

#include "arch.h"

/** Parse an architecture from an XML file stream.

    @param[in] stream = file stream

    @return the parsed architecture or NULL in case of error */
GDD_Arch *GDD_arch_of_xml_stream(FILE *stream);

/** Parse an architecture from a file.

    @param[in] filename = filename

    @return the parsed architecture or NULL in case of error */
GDD_Arch *GDD_arch_of_xml_file(const char *filename);

#endif
